/**
*	eepseq.c
*	EEPROMQ
*	Copyright Junnichi Tomaru
*/
#include	"remoir.h"

const char	testmac[] = { 0x00, 0x50, 0xc2, 0x96, 0x00, 0x03 };	/* eXgpMACAhX */


/**
*	EEPROMMACAhXǂݍ
*	 in	Ȃ
*	out	Ȃ
*/
void	read_macaddress( void )
{
	ui_t	t;
	char	i, j;

	t.data = geteeprom( EEP_MAC );	/* MACAhXԎ擾 */
	if( t.data == 0xffff ){		/* o^ĂȂꍇ */
		memcpy( mac_address, testmac, PHYSICALADDR_SIZE );
	}
	else{
		for( i = j = 0; i < 3; i++ ){
			t.data = geteeprom( EEP_MAC + i );	/* MACAhX擾 */
			mac_address[j] = t.bytes.hi;
			j++;
			mac_address[j] = t.bytes.lo;
			j++;
		}
	}
}


/**
*	EEPROMHTTP|[gǂݍ
*	 in	Ȃ
*	out	Ȃ
*/
void	read_httpport( void )
{
	http_port = geteeprom( EEP_HTTP );
	if( http_port == 0xffff ){	/* ݒ肳ĂȂ */
		http_port = 80U;
	}
}


/**
*	EEPROMzXgǂݍ
*	 in	Ȃ
*	out	Ȃ
*/
void	read_hostname( void )
{
	ui_t	t;
	char	i, j;

	if( geteeprom( EEP_HOST ) == 0xffff ){	/* ݒ肳ĂȂ */
		strcpy( host_name, "REMOTE-Ir" );
	}
	else{
		for( i = j = 0; i < 8; i++ ){	/* zXg擾 */
			t.data = geteeprom( EEP_HOST + i );
			host_name[j] = t.bytes.hi;
			j++;
			host_name[j] = t.bytes.lo;
			j++;
		}
		host_name[16] = '\0';
	}
}


/**
*	EEPROMԊO|[gǂݍ
*	 in	Ȃ
*	out	Ȃ
*/
void	read_irportname( void )
{
	ui_t	t;
	char	i, j;

	if( geteeprom( EEP_PORT1 ) == 0xffff ){	/* ݒ肳ĂȂ */
		strcpy( irport1, "IrPort1" );
	}
	else{
		for( i = j = 0; i < 8; i++ ){	/* 擾 */
			t.data = geteeprom( EEP_PORT1 + i );
			irport1[j] = t.bytes.hi;
			j++;
			irport1[j] = t.bytes.lo;
			j++;
		}
		irport1[16] = '\0';
	}
	if( geteeprom( EEP_PORT2 ) == 0xffff ){	/* ݒ肳ĂȂ */
		strcpy( irport2, "IrPort2" );
	}
	else{
		for( i = j = 0; i < 8; i++ ){	/* 擾 */
			t.data = geteeprom( EEP_PORT2 + i );
			irport2[j] = t.bytes.hi;
			j++;
			irport2[j] = t.bytes.lo;
			j++;
		}
		irport2[16] = '\0';
	}
	if( geteeprom( EEP_PORT3 ) == 0xffff ){	/* ݒ肳ĂȂ */
		strcpy( irport3, "IrPort3" );
	}
	else{
		for( i = j = 0; i < 8; i++ ){	/* 擾 */
			t.data = geteeprom( EEP_PORT3 + i );
			irport3[j] = t.bytes.hi;
			j++;
			irport3[j] = t.bytes.lo;
			j++;
		}
		irport3[16] = '\0';
	}
	if( geteeprom( EEP_PORT4 ) == 0xffff ){	/* ݒ肳ĂȂ */
		strcpy( irport4, "IrPort4" );
	}
	else{
		for( i = j = 0; i < 8; i++ ){	/* 擾 */
			t.data = geteeprom( EEP_PORT4 + i );
			irport4[j] = t.bytes.hi;
			j++;
			irport4[j] = t.bytes.lo;
			j++;
		}
		irport4[16] = '\0';
	}
}


/**
*	EEPROMԊOǂݍ
*	 in	Ȃ
*	out	Ȃ
*/
void	read_irctrl( void )
{
	ui_t	t;
	char	i, j;

	if( geteeprom( EEP_IRFLG ) == 0xffff ){	/* ݒ肳ĂȂ */
		irflg = 0;
	}
	else{
		irflg = geteeprom( EEP_IRFLG );
	}
	if( geteeprom( EEP_CTRL1 ) == 0xffff ){	/* ݒ肳ĂȂ */
		strcpy( irdo1, "ݒ" );
	}
	else{
		for( i = j = 0; i < 8; i++ ){	/* 擾 */
			t.data = geteeprom( EEP_CTRL1 + i );
			irdo1[j] = t.bytes.hi;
			j++;
			irdo1[j] = t.bytes.lo;
			j++;
		}
		irdo1[16] = '\0';
	}
	if( geteeprom( EEP_CTRL2 ) == 0xffff ){	/* ݒ肳ĂȂ */
		strcpy( irdo2, "ݒ" );
	}
	else{
		for( i = j = 0; i < 8; i++ ){	/* 擾 */
			t.data = geteeprom( EEP_CTRL2 + i );
			irdo2[j] = t.bytes.hi;
			j++;
			irdo2[j] = t.bytes.lo;
			j++;
		}
		irdo2[16] = '\0';
	}
	if( geteeprom( EEP_CTRL3 ) == 0xffff ){	/* ݒ肳ĂȂ */
		strcpy( irdo3, "ݒ" );
	}
	else{
		for( i = j = 0; i < 8; i++ ){	/* 擾 */
			t.data = geteeprom( EEP_CTRL3 + i );
			irdo3[j] = t.bytes.hi;
			j++;
			irdo3[j] = t.bytes.lo;
			j++;
		}
		irdo3[16] = '\0';
	}
	if( geteeprom( EEP_CTRL4 ) == 0xffff ){	/* ݒ肳ĂȂ */
		strcpy( irdo4, "ݒ" );
	}
	else{
		for( i = j = 0; i < 8; i++ ){	/* 擾 */
			t.data = geteeprom( EEP_CTRL4 + i );
			irdo4[j] = t.bytes.hi;
			j++;
			irdo4[j] = t.bytes.lo;
			j++;
		}
		irdo4[16] = '\0';
	}
	if( geteeprom( EEP_CTRL5 ) == 0xffff ){	/* ݒ肳ĂȂ */
		strcpy( irdo5, "ݒ" );
	}
	else{
		for( i = j = 0; i < 8; i++ ){	/* 擾 */
			t.data = geteeprom( EEP_CTRL5 + i );
			irdo5[j] = t.bytes.hi;
			j++;
			irdo5[j] = t.bytes.lo;
			j++;
		}
		irdo5[16] = '\0';
	}
	if( geteeprom( EEP_CTRL6 ) == 0xffff ){	/* ݒ肳ĂȂ */
		strcpy( irdo6, "ݒ" );
	}
	else{
		for( i = j = 0; i < 8; i++ ){	/* 擾 */
			t.data = geteeprom( EEP_CTRL6 + i );
			irdo6[j] = t.bytes.hi;
			j++;
			irdo6[j] = t.bytes.lo;
			j++;
		}
		irdo6[16] = '\0';
	}
	if( geteeprom( EEP_CTRL7 ) == 0xffff ){	/* ݒ肳ĂȂ */
		strcpy( irdo7, "ݒ" );
	}
	else{
		for( i = j = 0; i < 8; i++ ){	/* 擾 */
			t.data = geteeprom( EEP_CTRL7 + i );
			irdo7[j] = t.bytes.hi;
			j++;
			irdo7[j] = t.bytes.lo;
			j++;
		}
		irdo7[16] = '\0';
	}
}


/**
*	EEPROMpX[hǂݏo
*	 in	Ȃ
*	out	Ȃ
*/
void	read_password( void )
{
	ui_t	t;
	char	i, j;

	if( geteeprom( EEP_PW ) == 0xffff ){	/* ݒ肳ĂȂ */
		strcpy( password, "12345" );
	}
	else{
		for( i = j = 0; i < 4; i++ ){	/* 擾 */
			t.data = geteeprom( EEP_PW + i );
			password[j] = t.bytes.hi;
			j++;
			password[j] = t.bytes.lo;
			j++;
		}
		password[8] = '\0';
	}
}


/* end of eepseq.c */
