/**
*	ut.c
*	Tu[`W
*	Copyright (c)Junnichi Tomaru
*/
#include	<stdlib.h>
#include	<ctype.h>
#include	<string.h>
#include	"define.h"
#include	"ut.h"

const char	hexnum[] = { '0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F' };


/**
*	lPUi(unsigned char)
*	 in	num:f[^
*		buf:i[敶
*	out	obt@|C^
*/
char	*uctoahz( byte num, char *buf )
{
	union{
		byte	data;
		struct{
			byte	hi : 4;	/* ʂSrbg */
			byte	lo : 4;	/* ʂSrbg */
		} nbl;
	} uni;

	uni.data = num;
	*( buf + 0 ) = *( hexnum + uni.nbl.hi );
	*( buf + 1 ) = *( hexnum + uni.nbl.lo );
	*( buf + 2 ) = '\0';

	return	buf;
}


/**
*	lPOi(unsigned char,[TvXȂ)
*	 in	num:f[^
*		buf:i[敶
*	out	obt@|C^
*/
char	*uctoaz( byte num, char *buf )
{
	byte	n;
	char	i, *p;

	p = buf;
	for( n = 100; n > 1; n /= 10, p++ ){
		i = num / n;
		num %= n;
		*p = ( char )( i + '0' );
	}
	*p = num + '0';
	*( p + 1 ) = '\0';

	return	buf;
}


/**
*	AXL[(unsigned short,[TvXȂ)
*	 in	num:f[^
*		buf:i[敶
*	out	obt@|C^
*/
char	*utoaz( word num, char *buf )
{
	word	n;
	int	i;
	char	*p;

	p = buf;
	for( n = 10000U; n > 1; n /= 10, p++ ){
		i = num / n;
		num %= n;
		*p = ( char )( i + 0x30 );
	}
	*p = num + 0x30;
	*( p + 1 ) = '\0';

	return	buf;
}


/**
*	AXL[(unsigned long)
*	 in	num:f[^
*		buf:i[敶
*	out	obt@|C^
*/
char	*ultoaz( dword num, char *buf )
{
	dword	n;
	int	i;
	char	*p;

	p = buf;
	for( n = 1000000000LU; n > 1L; n /= 10L, p++ ){
		i = num / n;
		num %= n;
		*p = ( char )( i + 0x30 );
	}
	*p = num + 0x30;
	*( p + 1 ) = '\0';

	return	buf;
}


/**
*	AXL[(unsigned long,[TvX)
*	 in	num:f[^
*		buf:i[敶
*	out	obt@|C^
*/
char	*ultoa( dword num, char *buf )
{
	dword	n;
	int	i;
	char	f, *p;

	p = buf;
	f = 0;
	for( n = 1000000000LU; n > 1L; n /= 10L, p++ ){
		i = num / n;
		num %= n;
		if(( f == 0 ) && ( i != 0 )){
			f = 1;
		}
		if( f == 1 ){
			*p = ( char )( i + 0x30 );
		}
	}
	*p = num + 0x30;
	*( p + 1 ) = '\0';

	return	buf;
}


/**
*	zXglbg[ÑoCgI[_ϊ(16bit)
*	 in	ւf[^
*	out	ւ̃f[^
*/
word	htons( word data )
{
#if defined( LITTLE_ENDIAN )
	ui_t	ret, tmp;

	tmp.data = data;
	ret.bytes.lo = tmp.bytes.hi;
	ret.bytes.hi = tmp.bytes.lo;
	return	ret.data;
#else
	return	data;
#endif
}


/**
*	lbg[NzXg̃oCgI[_ϊ(16bit)
*	 in	ւf[^
*	out	ւ̃f[^
*/
word	ntohs( word data )
{
	return	htons( data );
}


/**
*	zXglbg[ÑoCgI[_ϊ(32bit)
*	 in	ւf[^
*	out	ւ̃f[^
*/
dword	htonl( dword data )
{
#if defined( LITTLE_ENDIAN )
	ul_t	ret, w;

	w.data = data;
	ret.bytes.ll = w.bytes.hh;
	ret.bytes.lh = w.bytes.hl;
	ret.bytes.hl = w.bytes.lh;
	ret.bytes.hh = w.bytes.ll;
	return	ret.data;
#else
	return	data;
#endif
}


/**
*	lbg[NzXg̃oCgI[_ϊ(32bit)
*	 in	ւf[^
*	out	ւ̃f[^
*/
dword	ntohl( dword data )
{
	return	htonl( data );
}


/**
*	obt@SoCgo
*	 in	   buf:f[^obt@
*		offset:oꏊ̃ItZbg
*	out	f[^
*/
dword	getlongvalue( byte *buf )
{
	ul_t	ret;

	ret.bytes.hh = *buf;
	buf++;
	ret.bytes.hl = *buf;
	buf++;
	ret.bytes.lh = *buf;
	buf++;
	ret.bytes.ll = *buf;

	return ret.data;
}


/**
*	obt@RoCgo(ʂQSrbgL)
*	 in	   buf:f[^obt@
*		offset:oꏊ̃ItZbg
*	out	f[^
*/
dword	getthreevalue( byte *buf )
{
	ul_t	ret;

	ret.bytes.hh = 0;
	ret.bytes.hl = *buf;
	buf++;
	ret.bytes.lh = *buf;
	buf++;
	ret.bytes.ll = *buf;

	return ret.data;
}


/**
*	obt@QoCgo
*	 in	   buf:f[^obt@
*		offset:oꏊ̃ItZbg
*	out	f[^
*/
word	getwordvalue( byte *buf )
{
	ui_t	ret;

	ret.bytes.hi = *buf;
	buf++;
	ret.bytes.lo = *buf;

	return	ret.data;
}


/**
*	obt@ɂSoCg̃f[^
*	 in	   buf:f[^obt@
*		offset:oꏊ̃ItZbg
*		   val:f[^
*	out	Ȃ
*/
void	setlongvalue( byte *buf, dword val )
{
	ul_t	tmp;

	tmp.data = val;
	*buf = tmp.bytes.hh;
	buf++;
	*buf = tmp.bytes.hl;
	buf++;
	*buf = tmp.bytes.lh;
	buf++;
	*buf = tmp.bytes.ll;
}


/**
*	obt@ɂRoCg̃f[^(ʂQSrbgL)
*	 in	   buf:f[^obt@
*		offset:oꏊ̃ItZbg
*		   val:f[^
*	out	Ȃ
*/
void	setthreevalue( byte *buf, dword val )
{
	ul_t	tmp;

	tmp.data = val;
	*buf = tmp.bytes.hl;
	buf++;
	*buf = tmp.bytes.lh;
	buf++;
	*buf = tmp.bytes.ll;
}


/**
*	obt@ɂQoCg̃f[^
*	 in	   buf:f[^obt@
*		offset:oꏊ̃ItZbg
*		   val:f[^
*	out	Ȃ
*/
void	setwordvalue( byte *buf, word val )
{
	ui_t	tmp;

	tmp.data = val;
	*buf = tmp.bytes.hi;
	buf++;
	*buf = tmp.bytes.lo;
}


/**
*	IPAhX𕶎ɂ
*	 in	ipadr:IPAhX
*		  buf:i[敶
*	out	obt@|C^
*/
char	*inet_ntoa( dword ipadr, char *buf )
{
	ul_t	tmp;
	char	*p;

	tmp.data = ipadr;
	uctoaz( tmp.bytes.hh, buf );
	strcat( buf, "." );
	p = strrchr( buf, '.' );
	uctoaz( tmp.bytes.hl, p + 1 );
	strcat( buf, "." );
	p = strrchr( buf, '.' );
	uctoaz( tmp.bytes.lh, p + 1 );
	strcat( buf, "." );
	p = strrchr( buf, '.' );
	uctoaz( tmp.bytes.ll, p + 1 );

	return	buf;
}


/**
*	ipAhXlong^ɕϊ
*	 in	adrstr	hoAhX
*		ɐƃhbgȊO܂ނƂ͂łȂ
*	out	ϊ̃AhX
*		"192.168.0.100" -> 0xc0a80064
*		G[̏ꍇINADDR_NONEԂ
*/
dword	inet_addr( char *adrstr )
{
	char	*p, *q, tmp[32];
	int	i;
	dword	ret;

	ret = 0;
	strcpy( tmp, adrstr );
	p = q = tmp;
	for( i = 0; i < 16; i++, q++ ){
		if( *q == '.' ){
			*q = '\0';
			ret |= atol( p );
			ret <<= 8;
			p = q + 1;
		}
		else if( *q == '\0' ){
			*q = '\0';
			ret |= atol( p );
			break;
		}
		else if( isdigit( *q ) == 0 ){
			ret = INADDR_NONE;
			break;
		}
	}
	return	ret;
}


/* end of ut.c */
